package Src;

import java.util.ArrayList;

public class petitGraphe {
	
	// nb Sommets afin d'initialiser la liste des sommets
	public static int nbSommetsInit;
	
	// La liste des Stations
	private ArrayList<Sommet> listeStations;
	//liste des sommets provenant du graphe principal
	private ArrayList<Sommet> listeSommets;
	// La liste des trajets
	private ArrayList<ArrayList<Trajet>> listeTrajets;
	// On initialise le nb de sommets
	private int nbSommet = 0 ;
	
	public petitGraphe(int nbSommet, Graphe graph) {
		nbSommetsInit = nbSommet;
		listeStations = new ArrayList<Sommet>(nbSommetsInit);
		listeTrajets = new ArrayList<ArrayList<Trajet>>(nbSommetsInit+2);
		for(int i = 0; i<nbSommetsInit+2; i++)
			listeTrajets.add(new ArrayList<Trajet>());
		listeSommets = graph.getListeSommets();
	}
	
	
	public ArrayList<Sommet> getListeStations() {
		return listeStations;
	}
	
	public ArrayList<ArrayList<Trajet>> getListeTrajets() {
		return listeTrajets;
	}
	
	public boolean trajetExiste(int deb,int fin){
		int indice = getId(deb);
		for (int i=0; i<listeTrajets.get(indice).size(); i++){
			if(listeTrajets.get(indice).get(i).getDeb()==fin || listeTrajets.get(indice).get(i).getFin()==fin)
				return true;
		}
		return false;
	}
	
	public int getNbSommet() {
		return nbSommet;
	}
	
	public void insererSommet(int som){
		listeStations.add(nbSommet,listeSommets.get(som));
		this.nbSommet++;
	}
	
	public void supprSommet(int som){
		int indice = getId(som);
		listeStations.remove(indice);
		for(int i=0;i<listeTrajets.get(indice).size();i++)
			listeTrajets.get(indice).remove(i);
		nbSommet--;
	}
	
	public void ajouterTrajet(Trajet trajet, int som){
		int indice = getId(som);
		listeTrajets.get(indice).add(listeTrajets.get(indice).size(),trajet);
	}
	
	public int getId(int numSom){
		for(int i=0;i<listeStations.size();i++){
			if(listeStations.get(i).getIdSom()==numSom)
				return i;
		}
		return -1;
	}
	
	public int getNum(int Id){
		return listeStations.get(Id).getIdSom();
	}
	
	public String toString(){
		String retour = "";
		for(int i=0; i<listeStations.size();i++){
			retour += "["+i+"/"+getNum(i)+"/"+listeTrajets.get(i).size()+"]\n";
		}
		return retour;
	}
}
